#ifndef FILETHREAD_H
#define FILETHREAD_H

#ifndef SERVER_H
#include "server.h"
#endif

/* Size of the data chunk used to check for overlap when resuming (download) */
#define RESUME_OVERLAP 4096

void ft_upload_thread(gpointer);
void ft_download_thread(gpointer);

typedef struct {
  Connection *c;
  char *name;
  HLObject *remote_path;
  char *local_path;
  Task *task;
  Thread thread;
  HLTransaction *transaction;
  int xferid;
  int server_queue_no;
  int retry_no,delay_remaining;
  unsigned int is_active,is_upload,is_text,has_thread,is_dequeued : 1;
  int current_bytes,session_bytes,total_bytes;
  GtkWidget *dialog;
  FILE *fd;
  FILE *localfile;
} FileTransfer;

#endif